unit Uwriter;
{*
 simple exemple pour partager une structure type record entre plusieurs process
 Y.Lafargue contact@ly-asds.com 
*}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

Type
  tag_TrfData = record
    lpdata   : array[0..255] of char;
    cbInQue  : DWORD;
    cbOutQue : DWORD;
  end;
  TTrfData = tag_TrfData;
  PTrfData = ^TTrfData;

Type
  TCFileMapping = class(TObject)
   private
    hFileMape                   : Thandle;
    lpMapAddress                : pointer;
    TrfData                     : PTrfData;
    FFileMapResult              : String;
    HData                       : string;
   protected
    property    FileMapResult   : String read FFileMapResult;
    property    FData           : String read HData write HData;
   public
    constructor Create;
    destructor  destroy; override;
    function    Close           : boolean;
    function    OpenW           : boolean;
    function    Write           : boolean;
   end;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1        : TForm1;
  CFileMapping : TCFileMapping = nil;

implementation

{$R *.DFM}



{******************************************************************************}
{*                                TFileMapping                                *}
{******************************************************************************}


{*----------------------------------------------------------------------------*}
constructor TCFilemapping.Create;
begin
 Inherited Create;
 hFileMape    := 0;
 lpMapAddress := nil;
 Getmem(TrfData,sizeof(TTrfData));
end;



{*----------------------------------------------------------------------------*}
destructor TCFileMapping.destroy;
begin
 if Assigned(TrfData) then Freemem(TrfData);
 Inherited destroy;
end;



{*----------------------------------------------------------------------------*}
function TCFilemapping.OpenW : boolean;
begin

 Result := false;

 If hFileMape <> 0 then begin
   FFileMapResult := ' "FileMapping" already open ! ';
   exit;
 End;


 hFileMape := CreateFileMapping($FFFFFFFF,
                                nil,
                                PAGE_READWRITE,
                                0,
                                sizeof(TTrfData),
                                pchar('MyLYWriterReaderMapping')
                                );


 If hFileMape = 0 then
   FFileMapResult := ' "FileMapping" opening in "writing mode".... raised ! '
 Else begin

   FFileMapResult := ' "FileMapping" open ';

   lpMapAddress := MapViewOfFile(hFileMape,
                                 File_MAP_ALL_ACCESS,
                                 0,
                                 0,
                                 0);

   If lpMapAddress = nil then
     FFileMapResult := FFileMapResult + ' Error in allocating of "FileMapping" '
   Else begin
     Result := true;
     FFileMapResult := FFileMapResult + ' "FileMapped" allocated ';
   End;
 End;

end;



{*----------------------------------------------------------------------------*}
Function TCFilemapping.Close : boolean;
begin

 Result:=True;

 If hFileMape <> 0 then begin
   If lpMapAddress <> nil then begin
     If not UnMapViewOfFile(lpMapAddress) then begin
       FFileMapResult := ' Error in deallocating of "FileMapping" ';
       Result := false;
       exit;
     End;
   End;
   lpMapAddress:=nil;
   If not CloseHandle(hFileMape) then begin
     FFileMapResult := ' Error in closing of "FileMapping" ';
     Result := false;
     exit;
   End;
   hFileMape := 0;
   FFileMapResult := ' "FileMapping" Closed ';
 End;

end;



{*----------------------------------------------------------------------------*}
function TCFilemapping.Write : boolean;
var
   Flength : integer;
begin

 Result:=true;

 If (hFileMape = 0) or (lpMapAddress = nil) or (TrfData = nil)
  then begin
    FFileMapResult :='';
    if hFileMape = 0 then FFileMapResult := FFileMapResult + ' "FileMapping" not open ';
    if lpMapAddress = nil then FFileMapResult := FFileMapResult + ' "FileMapping" not allocated ';
    if TrfData = nil then FFileMapResult := FFileMapResult + ' No strucure ready ';
    Result := false;
    exit;
  End;

  FFileMapResult := '';
  Flength := length(HData);

  if Flength > sizeof(TrfData^.lpdata) then begin
    Flength := sizeof(TrfData^.lpdata);
    FFileMapResult := ' Warning too much data ! ';
  end;

  StrlCopy(TrfData^.lpdata,Pchar(HData),Flength);
  TrfData^.cbInQue  :=1;
  TrfData^.cbOutQue :=Flength;

  copymemory(lpMapAddress,TrfData,sizeof(TTrfData));

  FFileMapResult := 'Data copied into "FileMapping" ';

end;





{******************************************************************************}
{*                                   TForm                                    *}
{******************************************************************************}


{*----------------------------------------------------------------------------*}
procedure TForm1.Button1Click(Sender: TObject);
begin

 if Assigned(CFileMapping)
  then begin
   CFileMapping.OpenW;
   label1.caption := CFileMapping.FileMapResult;
  end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.Button4Click(Sender: TObject);
var
    FText : string;
begin

  FText:=edit1.text;
  if trim(Ftext) = '' then exit;

  if Assigned(CFileMapping) then begin
   CFileMapping.FData:=Ftext;
   CFileMapping.Write;
   label1.caption := CFIleMapping.FileMapResult;
  end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.Button3Click(Sender: TObject);
begin

 if Assigned(CFileMapping) then begin
  CFIleMapping.close;
  label1.caption := CFIleMapping.FileMapResult;
 end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

 Canclose := True;
 if Assigned(CFileMapping) then
  if not CFIleMapping.Close then begin
   label1.caption := CFIleMapping.FileMapResult;
   CanClose := false;
  end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormCreate(Sender: TObject);
begin
 CFIleMapping := TCFIleMapping.create;
end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 CFileMapping.Free;
end;


end.
